// (c)  ..
//    11.08.2000

unit Unit5;
interface
uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, Mask, ExtCtrls, Menus,Unit6;
type
  TPriemStavka = class(TForm)
    Panel1: TPanel;
    label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EditFIO: TDBEdit;
    EditSUMMA: TDBEdit;
    EditNUMBER: TDBEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Button3: TButton;
    DBNavigator1: TDBNavigator;
    CheckBox1: TCheckBox;
    Button1: TButton;
    procedure prKom1(Sender: TObject);
    procedure prKom2(Sender: TObject);
    procedure prNoth(Sender: TObject);
    procedure prStart(Sender: TObject);
    procedure prCancel(Sender: TObject);
    procedure prOkSelect(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { private declarations }
  public
    { public declarations }
  end;
var
  PriemStavka: TPriemStavka;
  ZnResult:string;
  ZnKoeficient,SummObj:real;
  ButtonKey:integer;
implementation
{$R *.DFM}

{------------------------------------------------}

procedure TPriemStavka.prKom1(Sender: TObject);
begin
     RadioButton1.hide;
     RadioButton2.hide;
     RadioButton3.hide;
     Label4.show;
     Label2.Caption:='  '+ZnResult;
     Label4.Caption:=' = ';
     Label6.Caption:=DataModule6.TableCompit['KOEF_1'];
     Label2.Left:=10;
     Label4.Left:=10;

     ZnResult:=DataModule6.TableCompit['KOM1'];
     ZnKoeficient:=DataModule6.TableCompit['KOEF_1'];
     DataModule6.TableCompit.Edit;
     DataModule6.TableCompit['SUMM_1']:=DataModule6.TableCompit['SUMM_1']+EditSUMMA.EditText;
     ButtonKey:=2;
end;

{------------------------------------------------}

procedure TPriemStavka.prKom2(Sender: TObject);
begin
     RadioButton1.hide;
     RadioButton2.hide;
     RadioButton3.hide;
     Label4.show;
     Label2.Caption:='  '+ZnResult;
     Label4.Caption:=' = ';
     Label6.Caption:=DataModule6.TableCompit['KOEF_2'];
     Label2.Left:=10;
     Label4.Left:=10;

     ZnResult:=DataModule6.TableCompit['KOM2'];
     ZnKoeficient:=DataModule6.TableCompit['KOEF_2'];
     DataModule6.TableCompit.Edit;
     DataModule6.TableCompit['SUMM_2']:=DataModule6.TableCompit['SUMM_2']+EditSUMMA.EditText;
     ButtonKey:=2;
end;

{------------------------------------------------}

procedure TPriemStavka.prNoth(Sender: TObject);
begin
     RadioButton1.hide;
     RadioButton2.hide;
     RadioButton3.hide;
     Label4.show;
     Label2.Caption:='  ';
     Label4.Caption:=' = ';
     Label6.Caption:=DataModule6.TableCompit['KOEF_N'];
     Label2.Left:=10;
     Label4.Left:=10;

     ZnResult:='';
     ZnKoeficient:=DataModule6.TableCompit['KOEF_N'];
     DataModule6.TableCompit.Edit;
     DataModule6.TableCompit['SUMM_N']:=DataModule6.TableCompit['SUMM_N']+EditSUMMA.EditText;
     ButtonKey:=2;
end;

{------------------------------------------------}

procedure TPriemStavka.prStart(Sender: TObject);
begin
     RadioButton1.hide;
     RadioButton2.hide;
     RadioButton3.hide;
     Label2.hide;
     Label4.hide;

     Label1.show;
     Label3.show;
     Label5.show;
     EditSUMMA.show;
     EditNUMBER.show;
     EditFIO.show;

     EditFIO.SetFocus;
     Label1.caption:=' ';
     Label6.Caption:='';
     Label1.Left:=10;
     ButtonKey:=0;
     DataModule6.TableStavka.Open;
     DataModule6.TableStavka.Insert;
     DataModule6.TableStavka.Edit;
end;

{------------------------------------------------}

procedure TPriemStavka.prCancel(Sender: TObject);
begin
     PriemStavka.Close;
end;

{------------------------------------------------}

procedure TPriemStavka.prOkSelect(Sender: TObject);

{---}

procedure hide_show;
begin
     EditNUMBER.Hide;

     Label2.show;
     RadioButton1.show;
     RadioButton2.show;
     RadioButton3.show;

     RadioButton1.checked:=false;
     RadioButton2.checked:=false;
     RadioButton3.checked:=false;
     Label1.caption:='  = '+EditNUMBER.EditText;
     Label2.caption:='';
     RadioButton1.Caption:=DataModule6.TableCompit['KOM1'];
     RadioButton2.Caption:=DataModule6.TableCompit['KOM2'];
     RadioButton3.Caption:='';
     Label1.Left:=10;
     Label2.Left:=10;
end;

{---}

procedure proverka;
begin
     if DataModule6.TableCompit['NUMBER']=EditNUMBER.EditText then
     begin
          if Date >= DataModule6.TableCompit['DATE'] then
          begin
               Label2.show;
               Label2.Font.Color := clRed;
               Label2.caption:='      !!!';
               Label2.Left:=10;
               EditNUMBER.SetFocus;
               exit;
          end;
          Label2.Font.Color := clBlack;
          hide_show;
          exit;
     end;

     if DataModule6.TableCompit.eof then
     begin
          Label2.show;
          Label2.Font.Color := clRed;
          Label2.caption:='    !!!';
          Label2.Left:=10;
          EditNUMBER.SetFocus;
          end else begin
          DataModule6.TableCompit.Next;
          proverka;
     end;
end;

{---}

procedure ChangeCoeficient;
var old_koef1,old_koef2,old_koefn:real;
begin
     old_koef1:=DataModule6.TableCompit['KOEF_1'];
     old_koef2:=DataModule6.TableCompit['KOEF_2'];
     old_koefn:=DataModule6.TableCompit['KOEF_N'];

     if DataModule6.TableCompit['SUMM_1']>DataModule6.TableCompit['SUMM_N']+DataModule6.TableCompit['SUMM_2'] then
     begin
          DataModule6.TableCompit['KOEF_1']:=DataModule6.TableCompit['SUMM_N']+DataModule6.TableCompit['SUMM_2'];
          DataModule6.TableCompit['KOEF_1']:=0.9*(DataModule6.TableCompit['KOEF_1'])/(DataModule6.TableCompit['SUMM_1']);
     end;

     if DataModule6.TableCompit['SUMM_2']>DataModule6.TableCompit['SUMM_1']+DataModule6.TableCompit['SUMM_N'] then
     begin
          DataModule6.TableCompit['KOEF_2']:=DataModule6.TableCompit['SUMM_1']+DataModule6.TableCompit['SUMM_N'];
          DataModule6.TableCompit['KOEF_2']:=0.9*(DataModule6.TableCompit['KOEF_2'])/(DataModule6.TableCompit['SUMM_2']);
     end;

     if DataModule6.TableCompit['SUMM_N']>DataModule6.TableCompit['SUMM_1']+DataModule6.TableCompit['SUMM_2'] then
     begin
          DataModule6.TableCompit['KOEF_N']:=DataModule6.TableCompit['SUMM_1']+DataModule6.TableCompit['SUMM_2'];
          DataModule6.TableCompit['KOEF_N']:=0.9*(DataModule6.TableCompit['KOEF_N'])/(DataModule6.TableCompit['SUMM_N']);
     end;

     if old_koef1<DataModule6.TableCompit['KOEF_1'] then DataModule6.TableCompit['KOEF_1']:=0.9*old_koef1;
     if old_koef2<DataModule6.TableCompit['KOEF_2'] then DataModule6.TableCompit['KOEF_2']:=0.9*old_koef2;
     if old_koefn<DataModule6.TableCompit['KOEF_N'] then DataModule6.TableCompit['KOEF_N']:=0.9*old_koefn;
end;

{---}

procedure Ok1;
begin
     if (EditFIO.EditText<>'') and (EditSUMMA.EditText<>'') and (EditNUMBER.EditText<>'') then
     begin
          DataModule6.TableCompit.first;
          proverka;
     end;
end;

{---}

procedure Ok3;
begin
     if (EditFIO.EditText<>'') and (EditSUMMA.EditText<>'') then
     begin
          DataModule6.TableStavka['NUMBER']:=EditNUMBER.EditText;
          DataModule6.TableStavka['RESULT']:=ZnResult;
          DataModule6.TableStavka['SUMMA']:=EditSUMMA.EditText;
          DataModule6.TableStavka['KOEFICIENT']:=ZnKoeficient;
          DataModule6.TableStavka['FIO']:=EditFIO.EditText;
          DataModule6.TableStavka.Post;
          DataModule6.TableStavka.Insert;
          if CheckBox1.Checked=true then ChangeCoeficient;
          DataModule6.TableCompit.Post;
          PriemStavka.Close;
     end;
end;

{---}

begin
     Case ButtonKey of
          0: Ok1;
          2: Ok3;
     end;
end;

{------------------------------------------------}

procedure TPriemStavka.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     DataModule6.TableStavka.Delete;
end;
end.
